import { Component, OnInit, Input } from '@angular/core';
import { NgbActiveModal } from '@ng-bootstrap/ng-bootstrap';
import {
	BackendService,
	ScrumSprint
} from '../services/backend.service';

@Component({
	selector: 'app-task-form',
	templateUrl: './sprint-form.component.html',
	styleUrls: [ './sprint-form.component.css' ]
})
export class SprintFormComponent implements OnInit {
	@Input() public sprint: ScrumSprint;
	public editing: Boolean;
	public sprintid: string;

	constructor(private backendService: BackendService, private activeModalService: NgbActiveModal) {}

  ngOnInit(): void {
    if (this.sprint === null || this.sprint === undefined) {
      this.sprint = { title: '', startDate: '', endDate: ''}; //project id missing...
      this.editing = false;
    } else {
      this.editing = true;
    }
    document.getElementById('titleField').focus();
  }

	onSubmit() {
		if (this.editing) {
			this.backendService.putSprint(this.sprint).subscribe((response) => {
				if (response.status > 399) {
					alert('Fehler');
				}
			});
		} else {
			this.backendService.postSprint(this.sprint).subscribe((response) => {
				console.log('Sprint gespeichert!');
				if (response.status > 399) {
					alert('Fehler');
				}
			});
		}
		this.activeModalService.close(this.sprint);
	}

	onClose() {
		this.activeModalService.dismiss(this.sprint);
	}
}
